﻿using System;
using System.Collections.ObjectModel;
using System.Threading.Tasks;
using System.Windows.Input;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;
using Syncfusion.DataSource.Extensions;
using Xamarin.Forms;

namespace TestListView
{
    public class MainViewModel:ViewModelBase,IPageLifeCylceEvents
    {

        private ObservableCollection<CustomerCard> _privateprop;

        public ObservableCollection<CustomerCard> PublicProp
        {
            get { return _privateprop; }
            set { Set(() => PublicProp, ref _privateprop, value); }
        }

        //public ICommand SelectCardCommand { get; set; }


        private CustomerCard _selectedcard;

        public CustomerCard SelectedCard
        {
            get { return _selectedcard; }
            set { Set(() => SelectedCard, ref _selectedcard, value); }
        }

        //public MainViewModel()
        //{
        //    SelectCardCommand = new RelayCommand(CardSelection);
        //}

        public void CardSelection(CustomerCard selectedCard)
        {
            if (selectedCard == null) return;
            PublicProp.Clear();
            PublicProp = new ObservableCollection<CustomerCard>
            {
                new CustomerCard {Last4Digits = "Madhav", IsSelected = false},
                new CustomerCard {Last4Digits = "Omar", IsSelected = false},
                new CustomerCard {Last4Digits = "Richard",  IsSelected = false},
            };
            PublicProp.ForEach(x =>
            {
                x.IsSelected = x.Last4Digits == selectedCard.Last4Digits;

            });
        }

        public async Task<bool> LoadList()
        {
            PublicProp = new ObservableCollection<CustomerCard>
            {
                new CustomerCard {Last4Digits = "Madhav", IsSelected = false},
                new CustomerCard {Last4Digits = "Omar", IsSelected = true},
                new CustomerCard {Last4Digits = "Richard",  IsSelected = false},
            };
            return await Task.FromResult(true);
        }

        public async Task<bool> OnAppearing()
        {
            return await LoadList();
        }

        public void OnDisappearing()
        {
           
        }
    }
}
